"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.generateValidationMessage = void 0;

var generateValidationMessage = function generateValidationMessage(config) {
  var minAnswerChoices = config.minAnswerChoices,
      maxAnswerChoices = config.maxAnswerChoices;
  var answerChoicesMessage = "\nThere should be at least ".concat(minAnswerChoices, " ") + (maxAnswerChoices ? "and at most ".concat(maxAnswerChoices, " ") : '') + 'answer choices defined.' + '\nEvery answer choice should be non-blank and unique.';
  var correctAnswerMessage = '\nA correct answer must be defined.';
  var message = 'Validation requirements:' + answerChoicesMessage + correctAnswerMessage;
  return message;
};

exports.generateValidationMessage = generateValidationMessage;
//# sourceMappingURL=utils.js.map