"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = exports.StyledRadio = exports.StyledFormControlLabel = exports.StyledCheckbox = exports.ChoiceInput = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _FormControlLabel = _interopRequireDefault(require("@material-ui/core/FormControlLabel"));

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _styles = require("@material-ui/core/styles");

var _Checkbox = _interopRequireDefault(require("@material-ui/core/Checkbox"));

var _renderUi = require("@pie-lib/pie-toolbox/render-ui");

var _Radio = _interopRequireDefault(require("@material-ui/core/Radio"));

var _classnames = _interopRequireDefault(require("classnames"));

var _feedbackTick = _interopRequireDefault(require("./feedback-tick"));

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

var CLASS_NAME = 'multiple-choice-component';

var styleSheet = function styleSheet(theme) {
  return {
    row: {
      display: 'flex',
      alignItems: 'center',
      backgroundColor: _renderUi.color.background()
    },
    checkboxHolder: {
      display: 'flex',
      alignItems: 'center',
      backgroundColor: _renderUi.color.background(),
      flex: 1,
      '& label': {
        color: _renderUi.color.text(),
        '& > span': {
          fontSize: 'inherit'
        }
      }
    },
    horizontalLayout: (0, _defineProperty2["default"])({}, "& .".concat(CLASS_NAME), {
      // visually reduce right padding, but maintain accessibility padding for checkbox indicators to be circles
      // add margin to the top, left and bottom of the checkbox to keep the same spacing as before
      padding: theme.spacing.unit,
      margin: "".concat(theme.spacing.unit / 2, "px 0 ").concat(theme.spacing.unit / 2, "px ").concat(theme.spacing.unit / 2, "px")
    }),
    belowLayout: {
      '& > label': {
        alignItems: 'flex-start'
      }
    },
    belowLayoutCenter: {
      justifyContent: 'center',
      '& > label': {
        alignItems: 'center'
      }
    },
    belowSelectionComponent: {
      display: 'flex',
      alignItems: 'center',
      '& > span': {
        // visually reduce right padding, but maintain accessibility padding for checkbox indicators to be circles
        marginLeft: "-".concat(theme.spacing.unit, "px")
      }
    },
    srOnly: {
      position: 'absolute',
      left: '-10000px',
      top: 'auto',
      width: '1px',
      height: '1px',
      overflow: 'hidden'
    }
  };
};

var formStyleSheet = {
  label: {
    color: "".concat(_renderUi.color.text(), " !important"),
    //'var(--choice-input-color, black)'
    backgroundColor: _renderUi.color.background(),
    letterSpacing: 'normal'
  },
  disabled: {
    // apply to all children
    '& *': {
      cursor: 'not-allowed !important'
    }
  }
};
var StyledFormControlLabel = (0, _styles.withStyles)(formStyleSheet, {
  name: 'FormControlLabel'
})(function (props) {
  return /*#__PURE__*/_react["default"].createElement(_FormControlLabel["default"], (0, _extends2["default"])({}, props, {
    classes: {
      label: props.classes.label,
      disabled: props.classes.disabled
    }
  }));
});
exports.StyledFormControlLabel = StyledFormControlLabel;

var colorStyle = function colorStyle(varName, fallback) {
  return (0, _defineProperty2["default"])({}, "&.".concat(CLASS_NAME), {
    color: "var(--choice-input-".concat(varName, ", ").concat(fallback, ") !important")
  });
};

var inputStyles = {
  'correct-root': colorStyle('correct-color', _renderUi.color.text()),
  'correct-checked': colorStyle('correct-selected-color', _renderUi.color.correct()),
  //green[500]),
  'correct-disabled': colorStyle('correct-disabled-color', _renderUi.color.disabled()),
  //'grey'),
  'incorrect-root': colorStyle('incorrect-color', _renderUi.color.incorrect()),
  'incorrect-checked': colorStyle('incorrect-checked', _renderUi.color.incorrect()),
  //orange[500]),
  'incorrect-disabled': colorStyle('incorrect-disabled-color', _renderUi.color.disabled()),
  root: _objectSpread(_objectSpread({}, colorStyle('color', _renderUi.color.text())), {}, {
    '&:hover': {
      color: "".concat(_renderUi.color.primaryLight(), " !important")
    }
  }),
  checked: colorStyle('selected-color', _renderUi.color.primary()),
  disabled: _objectSpread(_objectSpread({}, colorStyle('disabled-color', _renderUi.color.text())), {}, {
    opacity: 0.6,
    cursor: 'not-allowed !important',
    pointerEvents: 'initial !important'
  }),
  focusVisibleUnchecked: {
    outline: "2px solid ".concat(_renderUi.color.focusUncheckedBorder()),
    backgroundColor: _renderUi.color.focusUnchecked()
  },
  focusVisibleChecked: {
    outline: "2px solid ".concat(_renderUi.color.focusCheckedBorder()),
    backgroundColor: _renderUi.color.focusChecked()
  }
};
var StyledCheckbox = (0, _styles.withStyles)(inputStyles)(function (props) {
  var correctness = props.correctness,
      classes = props.classes,
      checked = props.checked,
      onChange = props.onChange,
      disabled = props.disabled,
      value = props.value,
      id = props.id;

  var key = function key(k) {
    return correctness ? "".concat(correctness, "-").concat(k) : k;
  };

  var resolved = {
    root: classes[key('root')],
    checked: classes[key('checked')],
    disabled: classes[key('disabled')]
  };
  var miniProps = {
    checked: checked,
    onChange: onChange,
    disabled: disabled,
    value: value
  };
  return /*#__PURE__*/_react["default"].createElement(_Checkbox["default"], (0, _extends2["default"])({
    id: id,
    "aria-checked": checked,
    focusVisibleClassName: checked ? classes.focusVisibleChecked : classes.focusVisibleUnchecked,
    disableRipple: true
  }, miniProps, {
    className: CLASS_NAME,
    classes: {
      root: resolved.root,
      checked: resolved.checked,
      disabled: "".concat(correctness ? '' : resolved.disabled)
    }
  }));
});
exports.StyledCheckbox = StyledCheckbox;
var StyledRadio = (0, _styles.withStyles)(inputStyles)(function (props) {
  var correctness = props.correctness,
      classes = props.classes,
      checked = props.checked,
      onChange = props.onChange,
      disabled = props.disabled,
      value = props.value,
      id = props.id,
      tagName = props.tagName;

  var key = function key(k) {
    return correctness ? "".concat(correctness, "-").concat(k) : k;
  };

  var resolved = {
    root: classes[key('root')],
    checked: classes[key('checked')],
    disabled: classes[key('disabled')]
  };
  var miniProps = {
    checked: checked,
    onChange: onChange,
    disabled: disabled,
    value: value
  };
  return /*#__PURE__*/_react["default"].createElement(_Radio["default"], (0, _extends2["default"])({
    id: id,
    "aria-checked": checked,
    focusVisibleClassName: checked ? classes.focusVisibleChecked : classes.focusVisibleUnchecked,
    disableRipple: true
  }, miniProps, {
    className: CLASS_NAME,
    name: tagName,
    classes: {
      root: resolved.root,
      checked: resolved.checked,
      disabled: "".concat(correctness ? '' : resolved.disabled)
    }
  }));
});
exports.StyledRadio = StyledRadio;

var ChoiceInput = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2["default"])(ChoiceInput, _React$Component);

  var _super = _createSuper(ChoiceInput);

  function ChoiceInput(props) {
    var _this;

    (0, _classCallCheck2["default"])(this, ChoiceInput);
    _this = _super.call(this, props);
    _this.onToggleChoice = _this.onToggleChoice.bind((0, _assertThisInitialized2["default"])(_this));
    _this.choiceId = _this.generateChoiceId();
    _this.descId = "".concat(_this.choiceId, "-desc");
    return _this;
  }

  (0, _createClass2["default"])(ChoiceInput, [{
    key: "onToggleChoice",
    value: function onToggleChoice(event) {
      this.props.onChange(event);
    }
  }, {
    key: "generateChoiceId",
    value: function generateChoiceId() {
      return 'choice-' + (Math.random() * 10000).toFixed();
    }
  }, {
    key: "render",
    value: function render() {
      var _classNames;

      var _this$props = this.props,
          choiceMode = _this$props.choiceMode,
          disabled = _this$props.disabled,
          displayKey = _this$props.displayKey,
          feedback = _this$props.feedback,
          label = _this$props.label,
          correctness = _this$props.correctness,
          classes = _this$props.classes,
          className = _this$props.className,
          rationale = _this$props.rationale,
          hideTick = _this$props.hideTick,
          isEvaluateMode = _this$props.isEvaluateMode,
          choicesLayout = _this$props.choicesLayout,
          value = _this$props.value,
          checked = _this$props.checked,
          tagName = _this$props.tagName,
          isSelectionButtonBelow = _this$props.isSelectionButtonBelow;
      var Tag = choiceMode === 'checkbox' ? StyledCheckbox : StyledRadio;
      var classSuffix = choiceMode === 'checkbox' ? 'checkbox' : 'radio-button';
      var holderClassNames = (0, _classnames["default"])(classes.checkboxHolder, (_classNames = {}, (0, _defineProperty2["default"])(_classNames, classes.horizontalLayout, choicesLayout === 'horizontal'), (0, _defineProperty2["default"])(_classNames, classes.belowLayout, isSelectionButtonBelow && choicesLayout !== 'grid'), (0, _defineProperty2["default"])(_classNames, classes.belowLayoutCenter, isSelectionButtonBelow && choicesLayout === 'grid'), _classNames));

      var choicelabel = /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, displayKey && !isSelectionButtonBelow ? /*#__PURE__*/_react["default"].createElement("span", {
        className: classes.row
      }, displayKey, ".", "\xA0", /*#__PURE__*/_react["default"].createElement(_renderUi.PreviewPrompt, {
        className: "label",
        prompt: label,
        tagName: "span"
      })) : /*#__PURE__*/_react["default"].createElement(_renderUi.PreviewPrompt, {
        className: "label",
        prompt: label,
        tagName: "span"
      }));

      var screenReaderLabel = /*#__PURE__*/_react["default"].createElement("span", {
        id: this.descId,
        className: classes.srOnly
      }, choiceMode === 'checkbox' ? 'Checkbox to select the answer below' : 'Radio button to select the answer below');

      var tagProps = {
        disabled: disabled,
        checked: checked,
        correctness: correctness,
        tagName: tagName,
        value: value,
        id: this.choiceId,
        onChange: this.onToggleChoice,
        'aria-describedby': this.descId
      };
      var hasMathOrImage = typeof label === 'string' && (label.includes('<math') || label.includes('\\(') || label.includes('\\[') || label.includes('<img') || label.includes('data-latex') || label.includes('data-raw') || label.includes('<mjx-container'));
      var control = isSelectionButtonBelow ? /*#__PURE__*/_react["default"].createElement("span", {
        className: classes.belowSelectionComponent
      }, hasMathOrImage && screenReaderLabel, /*#__PURE__*/_react["default"].createElement(Tag, (0, _extends2["default"])({}, tagProps, {
        style: {
          padding: 0
        }
      })), displayKey ? "".concat(displayKey, ".") : '') : /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, hasMathOrImage && screenReaderLabel, /*#__PURE__*/_react["default"].createElement(Tag, tagProps));
      return /*#__PURE__*/_react["default"].createElement("div", {
        className: (0, _classnames["default"])(className, 'corespring-' + classSuffix, 'choice-input')
      }, /*#__PURE__*/_react["default"].createElement("div", {
        className: classes.row
      }, !hideTick && isEvaluateMode && /*#__PURE__*/_react["default"].createElement(_feedbackTick["default"], {
        correctness: correctness
      }), /*#__PURE__*/_react["default"].createElement("div", {
        className: (0, _classnames["default"])(holderClassNames, 'checkbox-holder')
      }, /*#__PURE__*/_react["default"].createElement(StyledFormControlLabel, {
        label: choicelabel,
        value: value,
        htmlFor: this.choiceId,
        labelPlacement: isSelectionButtonBelow ? 'top' : undefined,
        control: control
      }))), rationale && /*#__PURE__*/_react["default"].createElement(_renderUi.PreviewPrompt, {
        className: "rationale",
        defaultClassName: "rationale",
        prompt: rationale
      }), /*#__PURE__*/_react["default"].createElement(_renderUi.Feedback, {
        feedback: feedback,
        correctness: correctness
      }));
    }
  }]);
  return ChoiceInput;
}(_react["default"].Component);

exports.ChoiceInput = ChoiceInput;
(0, _defineProperty2["default"])(ChoiceInput, "propTypes", {
  choiceMode: _propTypes["default"].oneOf(['radio', 'checkbox']),
  displayKey: _propTypes["default"].string,
  checked: _propTypes["default"].bool.isRequired,
  correctness: _propTypes["default"].string,
  disabled: _propTypes["default"].bool.isRequired,
  feedback: _propTypes["default"].string,
  label: _propTypes["default"].string.isRequired,
  rationale: _propTypes["default"].string,
  onChange: _propTypes["default"].func.isRequired,
  value: _propTypes["default"].string.isRequired,
  classes: _propTypes["default"].object,
  className: _propTypes["default"].string,
  hideTick: _propTypes["default"].bool,
  isEvaluateMode: _propTypes["default"].bool,
  choicesLayout: _propTypes["default"].oneOf(['vertical', 'grid', 'horizontal']),
  isSelectionButtonBelow: _propTypes["default"].bool
});
(0, _defineProperty2["default"])(ChoiceInput, "defaultProps", {
  rationale: null,
  checked: false,
  isEvaluateMode: false
});

var _default = (0, _styles.withStyles)(styleSheet)(ChoiceInput);

exports["default"] = _default;
//# sourceMappingURL=choice-input.js.map