"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = exports.Choice = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _styles = require("@material-ui/core/styles");

var _classnames = _interopRequireDefault(require("classnames"));

var _choiceInput = _interopRequireDefault(require("./choice-input"));

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var Choice = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2["default"])(Choice, _React$Component);

  var _super = _createSuper(Choice);

  function Choice() {
    var _this;

    (0, _classCallCheck2["default"])(this, Choice);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "onChange", function (choice) {
      var _this$props = _this.props,
          disabled = _this$props.disabled,
          onChoiceChanged = _this$props.onChoiceChanged;

      if (!disabled) {
        onChoiceChanged(choice);
      }
    });
    return _this;
  }

  (0, _createClass2["default"])(Choice, [{
    key: "render",
    value: function render() {
      var _classNames;

      var _this$props2 = this.props,
          choice = _this$props2.choice,
          index = _this$props2.index,
          choicesLength = _this$props2.choicesLength,
          showCorrect = _this$props2.showCorrect,
          isEvaluateMode = _this$props2.isEvaluateMode,
          choiceMode = _this$props2.choiceMode,
          disabled = _this$props2.disabled,
          checked = _this$props2.checked,
          correctness = _this$props2.correctness,
          displayKey = _this$props2.displayKey,
          classes = _this$props2.classes,
          choicesLayout = _this$props2.choicesLayout,
          gridColumns = _this$props2.gridColumns,
          isSelectionButtonBelow = _this$props2.isSelectionButtonBelow,
          selectedAnswerBackgroundColor = _this$props2.selectedAnswerBackgroundColor,
          tagName = _this$props2.tagName;
      var choiceClass = 'choice' + (index === choicesLength - 1 ? ' last' : '');
      var feedback = !isEvaluateMode || showCorrect ? '' : choice.feedback;

      var choiceProps = _objectSpread(_objectSpread({}, choice), {}, {
        checked: checked,
        choiceMode: choiceMode,
        disabled: disabled,
        feedback: feedback,
        correctness: correctness,
        displayKey: displayKey,
        index: index,
        choicesLayout: choicesLayout,
        gridColumns: gridColumns,
        onChange: this.onChange,
        isEvaluateMode: isEvaluateMode,
        isSelectionButtonBelow: isSelectionButtonBelow,
        tagName: tagName
      });

      var names = (0, _classnames["default"])(classes.choice, (_classNames = {}, (0, _defineProperty2["default"])(_classNames, classes.noBorder, index === choicesLength - 1 || choicesLayout !== 'vertical'), (0, _defineProperty2["default"])(_classNames, classes.horizontalLayout, choicesLayout === 'horizontal'), _classNames));
      var choiceBackground = selectedAnswerBackgroundColor && checked ? selectedAnswerBackgroundColor : 'initial';
      return /*#__PURE__*/_react["default"].createElement("div", {
        className: choiceClass,
        key: index,
        style: {
          backgroundColor: choiceBackground
        }
      }, /*#__PURE__*/_react["default"].createElement(_choiceInput["default"], (0, _extends2["default"])({}, choiceProps, {
        className: names
      })));
    }
  }]);
  return Choice;
}(_react["default"].Component);

exports.Choice = Choice;
(0, _defineProperty2["default"])(Choice, "propTypes", {});
Choice.propTypes = {
  choiceMode: _propTypes["default"].oneOf(['radio', 'checkbox']),
  choice: _propTypes["default"].object,
  disabled: _propTypes["default"].bool.isRequired,
  onChoiceChanged: _propTypes["default"].func,
  classes: _propTypes["default"].object.isRequired,
  index: _propTypes["default"].number,
  choicesLength: _propTypes["default"].number,
  showCorrect: _propTypes["default"].bool,
  isEvaluateMode: _propTypes["default"].bool,
  checked: _propTypes["default"].bool,
  correctness: _propTypes["default"].string,
  displayKey: _propTypes["default"].string,
  choicesLayout: _propTypes["default"].oneOf(['vertical', 'grid', 'horizontal']),
  gridColumns: _propTypes["default"].string,
  selectedAnswerBackgroundColor: _propTypes["default"].string,
  tagName: _propTypes["default"].string,
  isSelectionButtonBelow: _propTypes["default"].bool
};

var _default = (0, _styles.withStyles)(function (theme) {
  return {
    choice: {
      paddingTop: theme.spacing.unit * 2.5,
      paddingBottom: theme.spacing.unit + 2,
      paddingLeft: theme.spacing.unit + 2,
      paddingRight: theme.spacing.unit + 2,
      borderBottom: "1px solid ".concat(theme.palette.grey[300])
    },
    noBorder: {
      borderBottom: 'none'
    },
    horizontalLayout: {
      paddingRight: theme.spacing.unit * 2.5,
      '& label': {
        marginRight: theme.spacing.unit // '& span:first-child': {
        //   paddingRight: 0
        // }

      }
    }
  };
})(Choice);

exports["default"] = _default;
//# sourceMappingURL=choice.js.map