"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireDefault(require("react"));

var _reactTransitionGroup = require("react-transition-group");

var _styles = require("@material-ui/core/styles");

var _propTypes = _interopRequireDefault(require("prop-types"));

var _renderUi = require("@pie-lib/pie-toolbox/render-ui");

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var stylesheet = {
  incorrect: {
    fill: "var(--feedback-incorrect-bg-color, ".concat(_renderUi.color.incorrect(), ")")
  },
  correct: {
    fill: "var(--feedback-correct-bg-color, ".concat(_renderUi.color.correct(), ")")
  },
  feedbackTick: {
    width: '33px',
    height: '33px',
    '& svg': {
      position: 'absolute',
      display: 'inline-block',
      width: '33px',
      height: '33px',
      verticalAlign: 'middle',
      '& hide': {
        display: 'none'
      }
    }
  },
  feedbackTickEnter: {
    opacity: '0',
    left: '-50px'
  },
  feedbackTickEnterActive: {
    opacity: '1',
    left: '0px',
    transition: 'left 500ms ease-in 200ms, opacity 500ms linear 200ms'
  },
  feedbackTickLeave: {
    opacity: '1',
    left: '0px'
  },
  feedbackTickLeaveActive: {
    opacity: '0',
    left: '-50px',
    transition: 'left 300ms ease-in, opacity 300ms'
  }
};

var FeedbackTick = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2["default"])(FeedbackTick, _React$Component);

  var _super = _createSuper(FeedbackTick);

  function FeedbackTick(props) {
    var _this;

    (0, _classCallCheck2["default"])(this, FeedbackTick);
    _this = _super.call(this, props);
    _this.incorrectIcon = /*#__PURE__*/_react["default"].createElement("svg", {
      key: "1",
      preserveAspectRatio: "xMinYMin meet",
      x: "0px",
      y: "0px",
      viewBox: "0 0 44 40",
      style: {
        enableBackground: 'new 0 0 44 40'
      }
    }, /*#__PURE__*/_react["default"].createElement("g", null, /*#__PURE__*/_react["default"].createElement("rect", {
      x: "11",
      y: "17.3",
      transform: "matrix(0.7071 -0.7071 0.7071 0.7071 -7.852 19.2507)",
      className: _this.props.classes.incorrect,
      width: "16.6",
      height: "3.7"
    }), /*#__PURE__*/_react["default"].createElement("rect", {
      x: "17.4",
      y: "10.7",
      transform: "matrix(0.7071 -0.7071 0.7071 0.7071 -7.8175 19.209)",
      className: _this.props.classes.incorrect,
      width: "3.7",
      height: "16.6"
    })));
    _this.correctIcon = /*#__PURE__*/_react["default"].createElement("svg", {
      key: "2",
      preserveAspectRatio: "xMinYMin meet",
      version: "1.1",
      x: "0px",
      y: "0px",
      viewBox: "0 0 44 40",
      style: {
        enableBackground: 'new 0 0 44 40'
      }
    }, /*#__PURE__*/_react["default"].createElement("polygon", {
      className: _this.props.classes.correct,
      points: "19.1,28.6 11.8,22.3 14.4,19.2 17.9,22.1 23.9,11.4 27.5,13.4"
    }));
    return _this;
  }

  (0, _createClass2["default"])(FeedbackTick, [{
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$props = this.props,
          correctness = _this$props.correctness,
          classes = _this$props.classes;

      var icon = function () {
        if (correctness === 'incorrect') {
          return _this2.incorrectIcon;
        } else if (correctness === 'correct') {
          return _this2.correctIcon;
        }
      }();

      return /*#__PURE__*/_react["default"].createElement("div", {
        className: classes.feedbackTick
      }, /*#__PURE__*/_react["default"].createElement(_reactTransitionGroup.TransitionGroup, null, correctness && /*#__PURE__*/_react["default"].createElement(_reactTransitionGroup.CSSTransition, {
        classNames: {
          enter: classes.feedbackTickEnter,
          enterActive: classes.feedbackTickEnterActive,
          exit: classes.feedbackTickLeave,
          exitActive: classes.feedbackTickLeaveActive
        },
        timeout: {
          enter: 700,
          exit: 300
        }
      }, icon)));
    }
  }]);
  return FeedbackTick;
}(_react["default"].Component);

(0, _defineProperty2["default"])(FeedbackTick, "propTypes", {
  classes: _propTypes["default"].object.isRequired,
  correctness: _propTypes["default"].string
});

var _default = (0, _styles.withStyles)(stylesheet, {
  name: 'FeedbackTick'
})(FeedbackTick);

exports["default"] = _default;
//# sourceMappingURL=feedback-tick.js.map