"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = exports.MultipleChoice = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _correctAnswerToggle = require("@pie-lib/pie-toolbox/correct-answer-toggle");

var _classnames = _interopRequireDefault(require("classnames"));

var _styles = require("@material-ui/core/styles");

var _renderUi = require("@pie-lib/pie-toolbox/render-ui");

var _translator = _interopRequireDefault(require("@pie-lib/pie-toolbox/translator"));

var _choice = _interopRequireDefault(require("./choice"));

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

// MultipleChoice
var translator = _translator["default"].translator;

var styles = function styles(theme) {
  return {
    main: {
      color: _renderUi.color.text(),
      backgroundColor: _renderUi.color.background(),
      '& *': {
        '-webkit-font-smoothing': 'antialiased'
      },
      position: 'relative',
      // remove border from legend tags inside main to override the OT default styles
      '& legend': {
        border: 'none !important'
      }
    },
    partLabel: {
      display: 'block',
      fontSize: 'inherit',
      margin: '0',
      fontWeight: 'normal',
      paddingBottom: theme.spacing.unit * 2
    },
    teacherInstructions: {
      marginBottom: theme.spacing.unit * 2
    },
    horizontalLayout: {
      display: 'flex',
      flexDirection: 'row',
      flexWrap: 'wrap'
    },
    gridLayout: {
      display: 'grid'
    },
    fieldset: {
      border: '0px',
      padding: '0.01em 0 0 0',
      margin: '0px',
      minWidth: '0px'
    },
    srOnly: {
      position: 'absolute',
      left: '-10000px',
      top: 'auto',
      width: '1px',
      height: '1px',
      overflow: 'hidden'
    },
    errorText: {
      fontSize: theme.typography.fontSize - 2,
      color: theme.palette.error.main,
      paddingTop: theme.spacing.unit
    }
  };
};

var MultipleChoice = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2["default"])(MultipleChoice, _React$Component);

  var _super = _createSuper(MultipleChoice);

  function MultipleChoice(props) {
    var _this;

    (0, _classCallCheck2["default"])(this, MultipleChoice);
    _this = _super.call(this, props);
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleChange", function (event) {
      var _event$target = event.target,
          value = _event$target.value,
          checked = _event$target.checked;
      var _this$props = _this.props,
          maxSelections = _this$props.maxSelections,
          onChoiceChanged = _this$props.onChoiceChanged,
          session = _this$props.session;

      if (session.value && session.value.length >= maxSelections) {
        // show/hide max selections error when user select/deselect an answer
        _this.setState({
          maxSelectionsErrorState: checked
        });

        if (checked) {
          // prevent selecting more answers
          return;
        }
      }

      onChoiceChanged({
        value: value,
        selected: checked,
        selector: 'Mouse'
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "onToggle", function () {
      if (_this.props.mode === 'evaluate') {
        _this.setState({
          showCorrect: !_this.state.showCorrect
        }, function () {
          if (_this.props.onShowCorrectToggle) {
            _this.props.onShowCorrectToggle();
          }
        });
      }
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "getCorrectness", function () {
      var choice = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
      var isCorrect = choice.correct;

      var isChecked = _this.isSelected(choice.value);

      if (_this.state.showCorrect) {
        return isCorrect ? 'correct' : undefined;
      }

      if (isCorrect) {
        if (isChecked) {
          // A correct answer is selected: marked with a green checkmark
          return 'correct';
        } else {
          // A correct answer is NOT selected: marked with an orange X
          return 'incorrect';
        }
      } else {
        if (isChecked) {
          // An incorrect answer is selected: marked with an orange X
          return 'incorrect';
        } else {
          // An incorrect answer is NOT selected: not marked
          return undefined;
        }
      }
    });
    _this.state = {
      showCorrect: _this.props.alwaysShowCorrect || false,
      maxSelectionsErrorState: false
    };
    _this.onToggle = _this.onToggle.bind((0, _assertThisInitialized2["default"])(_this));
    return _this;
  }

  (0, _createClass2["default"])(MultipleChoice, [{
    key: "isSelected",
    value: function isSelected(value) {
      var sessionValue = this.props.session && this.props.session.value;
      return sessionValue && sessionValue.indexOf && sessionValue.indexOf(value) >= 0;
    } // handleChange was added for accessibility. Please see comments and videos from PD-2441.

  }, {
    key: "UNSAFE_componentWillReceiveProps",
    value: function UNSAFE_componentWillReceiveProps(nextProps) {
      var _this2 = this;

      if (!nextProps.correctResponse && this.state.showCorrect !== false) {
        this.setState({
          showCorrect: false
        }, function () {
          if (_this2.props.onShowCorrectToggle) {
            _this2.props.onShowCorrectToggle();
          }
        });
      }

      if (nextProps.alwaysShowCorrect && this.state.showCorrect !== true) {
        this.setState({
          showCorrect: true
        }, function () {
          if (_this2.props.onShowCorrectToggle) {
            _this2.props.onShowCorrectToggle();
          }
        });
      }
    }
  }, {
    key: "indexToSymbol",
    value: function indexToSymbol(index) {
      if (this.props.keyMode === 'numbers') {
        return "".concat(index + 1);
      }

      if (this.props.keyMode === 'letters') {
        return String.fromCharCode(97 + index).toUpperCase();
      }

      return '';
    }
  }, {
    key: "getChecked",
    value: function getChecked(choice) {
      if (this.state.showCorrect) {
        return choice.correct || false;
      }

      return this.isSelected(choice.value);
    } // renderHeading function was added for accessibility.

  }, {
    key: "renderHeading",
    value: function renderHeading() {
      var _this$props2 = this.props,
          mode = _this$props2.mode,
          choiceMode = _this$props2.choiceMode,
          classes = _this$props2.classes;

      if (mode !== 'gather') {
        return null;
      }

      return choiceMode === 'radio' ? /*#__PURE__*/_react["default"].createElement("h2", {
        className: classes.srOnly
      }, "Multiple Choice Question") : /*#__PURE__*/_react["default"].createElement("h2", {
        className: classes.srOnly
      }, "Multiple Select Question");
    }
  }, {
    key: "render",
    value: function render() {
      var _classNames,
          _this3 = this;

      var _this$props3 = this.props,
          mode = _this$props3.mode,
          disabled = _this$props3.disabled,
          className = _this$props3.className,
          _this$props3$choices = _this$props3.choices,
          choices = _this$props3$choices === void 0 ? [] : _this$props3$choices,
          choiceMode = _this$props3.choiceMode,
          gridColumns = _this$props3.gridColumns,
          partLabel = _this$props3.partLabel,
          prompt = _this$props3.prompt,
          responseCorrect = _this$props3.responseCorrect,
          teacherInstructions = _this$props3.teacherInstructions,
          classes = _this$props3.classes,
          alwaysShowCorrect = _this$props3.alwaysShowCorrect,
          animationsDisabled = _this$props3.animationsDisabled,
          language = _this$props3.language,
          isSelectionButtonBelow = _this$props3.isSelectionButtonBelow,
          minSelections = _this$props3.minSelections,
          maxSelections = _this$props3.maxSelections,
          autoplayAudioEnabled = _this$props3.autoplayAudioEnabled,
          session = _this$props3.session,
          customAudioButton = _this$props3.customAudioButton;
      var _this$state = this.state,
          showCorrect = _this$state.showCorrect,
          maxSelectionsErrorState = _this$state.maxSelectionsErrorState;
      var isEvaluateMode = mode === 'evaluate';
      var showCorrectAnswerToggle = isEvaluateMode && !responseCorrect;
      var columnsStyle = gridColumns > 1 ? {
        gridTemplateColumns: "repeat(".concat(gridColumns, ", 1fr)")
      } : undefined;
      var selections = session.value && session.value.length || 0;

      var teacherInstructionsDiv = /*#__PURE__*/_react["default"].createElement(_renderUi.PreviewPrompt, {
        tagName: "div",
        className: "prompt",
        defaultClassName: "teacher-instructions",
        prompt: teacherInstructions
      });

      var getMultipleChoiceMinSelectionErrorMessage = function getMultipleChoiceMinSelectionErrorMessage() {
        if (minSelections && maxSelections) {
          return minSelections === maxSelections ? translator.t('translation:multipleChoice:minmaxSelections_equal', {
            lng: language,
            minSelections: minSelections
          }) : translator.t('translation:multipleChoice:minmaxSelections_range', {
            lng: language,
            minSelections: minSelections,
            maxSelections: maxSelections
          });
        }

        if (minSelections) {
          return translator.t('translation:multipleChoice:minSelections', {
            lng: language,
            minSelections: minSelections
          });
        }

        return '';
      };

      return /*#__PURE__*/_react["default"].createElement("div", {
        id: 'main-container',
        className: (0, _classnames["default"])(classes.main, className, 'multiple-choice')
      }, partLabel && /*#__PURE__*/_react["default"].createElement("h3", {
        className: classes.partLabel
      }, partLabel), this.renderHeading(), teacherInstructions && /*#__PURE__*/_react["default"].createElement("div", {
        className: classes.teacherInstructions
      }, !animationsDisabled ? /*#__PURE__*/_react["default"].createElement(_renderUi.Collapsible, {
        labels: {
          hidden: 'Show Teacher Instructions',
          visible: 'Hide Teacher Instructions'
        }
      }, teacherInstructionsDiv) : teacherInstructionsDiv), /*#__PURE__*/_react["default"].createElement("fieldset", {
        tabIndex: 0,
        className: classes.fieldset,
        role: choiceMode === 'radio' ? 'radiogroup' : 'group'
      }, /*#__PURE__*/_react["default"].createElement(_renderUi.PreviewPrompt, {
        className: "prompt",
        defaultClassName: "prompt",
        prompt: prompt,
        tagName: 'legend',
        autoplayAudioEnabled: autoplayAudioEnabled,
        customAudioButton: customAudioButton
      }), !alwaysShowCorrect && /*#__PURE__*/_react["default"].createElement(_correctAnswerToggle.CorrectAnswerToggle, {
        show: showCorrectAnswerToggle,
        toggled: showCorrect,
        onToggle: this.onToggle.bind(this),
        language: language
      }), /*#__PURE__*/_react["default"].createElement("div", {
        className: (0, _classnames["default"])((_classNames = {}, (0, _defineProperty2["default"])(_classNames, classes.gridLayout, this.props.choicesLayout === 'grid'), (0, _defineProperty2["default"])(_classNames, classes.horizontalLayout, this.props.choicesLayout === 'horizontal'), _classNames)),
        style: columnsStyle
      }, choices.map(function (choice, index) {
        return /*#__PURE__*/_react["default"].createElement(_choice["default"], {
          choicesLayout: _this3.props.choicesLayout,
          selectedAnswerBackgroundColor: _this3.props.selectedAnswerBackgroundColor,
          gridColumns: gridColumns,
          key: "choice-".concat(index),
          choice: choice,
          index: index,
          choicesLength: choices.length,
          showCorrect: showCorrect,
          isEvaluateMode: isEvaluateMode,
          choiceMode: choiceMode,
          disabled: disabled,
          tagName: partLabel ? "group-".concat(partLabel) : 'group',
          onChoiceChanged: _this3.handleChange,
          hideTick: choice.hideTick,
          checked: _this3.getChecked(choice),
          correctness: isEvaluateMode ? _this3.getCorrectness(choice) : undefined,
          displayKey: _this3.indexToSymbol(index),
          isSelectionButtonBelow: isSelectionButtonBelow
        });
      }))), choiceMode === 'checkbox' && selections < minSelections && /*#__PURE__*/_react["default"].createElement("div", {
        className: classes.errorText
      }, getMultipleChoiceMinSelectionErrorMessage()), choiceMode === 'checkbox' && maxSelectionsErrorState && /*#__PURE__*/_react["default"].createElement("div", {
        className: classes.errorText
      }, translator.t("translation:multipleChoice:maxSelections_".concat(maxSelections === 1 ? 'one' : 'other'), {
        lng: language,
        maxSelections: maxSelections
      })));
    }
  }]);
  return MultipleChoice;
}(_react["default"].Component);

exports.MultipleChoice = MultipleChoice;
(0, _defineProperty2["default"])(MultipleChoice, "propTypes", {
  className: _propTypes["default"].string,
  mode: _propTypes["default"].oneOf(['gather', 'view', 'evaluate']),
  choiceMode: _propTypes["default"].oneOf(['radio', 'checkbox']),
  keyMode: _propTypes["default"].oneOf(['numbers', 'letters', 'none']),
  choices: _propTypes["default"].array,
  partLabel: _propTypes["default"].string,
  prompt: _propTypes["default"].string,
  teacherInstructions: _propTypes["default"].string,
  session: _propTypes["default"].object,
  disabled: _propTypes["default"].bool,
  onChoiceChanged: _propTypes["default"].func,
  responseCorrect: _propTypes["default"].bool,
  classes: _propTypes["default"].object.isRequired,
  correctResponse: _propTypes["default"].array,
  choicesLayout: _propTypes["default"].oneOf(['vertical', 'grid', 'horizontal']),
  gridColumns: _propTypes["default"].string,
  alwaysShowCorrect: _propTypes["default"].bool,
  animationsDisabled: _propTypes["default"].bool,
  language: _propTypes["default"].string,
  selectedAnswerBackgroundColor: _propTypes["default"].string,
  onShowCorrectToggle: _propTypes["default"].func,
  isSelectionButtonBelow: _propTypes["default"].bool,
  minSelections: _propTypes["default"].number,
  maxSelections: _propTypes["default"].number,
  autoplayAudioEnabled: _propTypes["default"].bool,
  customAudioButton: {
    playImage: _propTypes["default"].string,
    pauseImage: _propTypes["default"].string
  }
});
MultipleChoice.defaultProps = {
  session: {
    value: []
  }
};

var _default = (0, _styles.withStyles)(styles)(MultipleChoice);

exports["default"] = _default;
//# sourceMappingURL=multiple-choice.js.map